#include "Vram.h"
#include "Chars.h"
#include "Movable.h"
#include "Sprite.h"
#include "Sound.h"

extern byte[] MonoPatternSource, ColorPatternSource, SpritePatternSource;

byte[CharHeight * 4 * Char_End] CharPattern;


void InitVram()
{
    MakePatternMono(Char_Ascii, MonoPatternSource + Char_Ascii * CharHeight, 64, 0x07);
    MakePatternMono(Char_Logo, MonoPatternSource + Char_Logo * CharHeight, 16 + 2 + 9, 0x0c);
    MakePatternMono(Char_Bedrock, MonoPatternSource + Char_Bedrock * CharHeight, 1, 0x0f);
    MakePatternColor(Char_Remain, ColorPatternSource, 4);
    MakeSpritePattern(SpritePatternSource, PatternCount);
}


word PrintC(word vram, byte c)
{
    return Put(vram, c - ' ');
}


void Put2C(word vram, byte c)
{
    repeat (2) {
        repeat (2) {
            vram = Put(vram, c);
            ++c;
        }
        vram += VramRowSize - 2 * VramStep;
    }
}


void Put2S(word vram, ptr<byte> pChars)
{
    repeat (2) {
        repeat (2) {
            vram = Put(vram, *pChars);
            ++pChars;
        }
        vram += VramRowSize - 2 * VramStep;
    }
}
